import 'package:flutter/material.dart';
import 'package:flutter_gadgets/flutter_gadgets.dart';

import '../const.dart';
import '../model/game.dart';
import '../view/welcome_screen.dart';

void onFabPressed(BuildContext context) {
  final model = ServiceContainer.instance.observableModel;
  final viewModel = model.getBean<WelcomeScreenVM>();
  if (viewModel.controller.text.trim().isNotEmpty) {
    model.putBean<Game>(
      Game(model.getBean<WelcomeScreenVM>().controller.text),
      notify: false,
    );
    Navigator.of(context).pushReplacementNamed(ROUTE_GAME);
  } else {
    viewModel.errorText = 'Please enter your name';
    model.notifyFor(WelcomeScreenVM);
  }
}
