import 'dart:math';

class Game {
  final _random = Random();
  String name;
  int _numberToGuess;
  String _hint;
  int _attempts;
  bool _numberFound;

  Game(this.name) {
    newGame();
  }

  void newGame() {
    _numberToGuess = _random.nextInt(100) + 1;
    // print('Number to guess: $_numberToGuess');
    _hint = 'Hello $name! Choose a number between 1 and 100.';
    _attempts = 0;
    _numberFound = false;
  }

  void nextTurn(int attempt) {
    _attempts++;
    if (attempt > _numberToGuess) {
      _hint = 'Try with a smaller number.';
    } else if (attempt < _numberToGuess) {
      _hint = 'Try with a bigger number.';
    } else {
      _hint =
          'Well done $name! You guessed it! The number to guess was $_numberToGuess!';
      _numberFound = true;
    }
  }

  String get hint => _hint;

  int get attempts => _attempts;

  bool get numberFound => _numberFound;
}
