import 'package:flutter/material.dart';
import 'package:flutter_gadgets/flutter_gadgets.dart';

import '../control/welcome_screen_control.dart';

class WelcomeScreenVM {
  TextEditingController controller;
  String errorText;
}

class WelcomeScreen extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    return ViewModelGadget<WelcomeScreenVM>(
      WelcomeScreenVM(),
      initStateCallback: (WelcomeScreenVM viewModel) {
        viewModel.controller = TextEditingController();
      },
      disposeCallback: (WelcomeScreenVM viewModel) {
        viewModel.controller.dispose();
      },
      child: _child(context),
    );
  }

  Widget _child(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: Text('Number Guess'),
        centerTitle: false,
      ),
      body: _body,
      floatingActionButton: FloatingActionButton(
        onPressed: () => onFabPressed(context),
        child: Icon(Icons.arrow_right_alt),
      ),
    );
  }

  Widget get _body {
    return Padding(
      padding: const EdgeInsets.all(8),
      child: Column(
        crossAxisAlignment: CrossAxisAlignment.center,
        children: [
          SubscriberGadget<WelcomeScreenVM>(
            builder: (_, viewModel) => TextField(
              controller: viewModel.controller,
              decoration: InputDecoration(
                labelText: 'Name',
                hintText: 'Enter your name',
                errorText: viewModel.errorText,
              ),
            ),
          ),
        ],
      ),
    );
  }
}
