import 'package:flutter/material.dart';
import 'package:flutter_gadgets/flutter_gadgets.dart';
import 'package:flutter_test/flutter_test.dart';

import '../utils.dart';

void main() {
  testWidgets('AppGadget tree construction', (tester) async {
    await tester.pumpWidget(AppGadget(child: Container()));
    expect(find.byType(ModelGadget), findsOneWidget);
    expect(ServiceContainer.instance.observableModel, isNotNull);

    await tester.pumpWidget(Container());
  });

  testWidgets('AppGadget tree construction with service', (tester) async {
    await tester.pumpWidget(AppGadget(
      child: Container(),
      services: {MockService: MockService()},
    ));
    expect(ServiceContainer.instance.get<MockService>(), isNotNull);
    expect(ServiceContainer.instance.observableModel.getBean<MockBean>(), isNull);

    await tester.pumpWidget(Container());
  });

  testWidgets('AppGadget tree construction with bean', (tester) async {
    await tester.pumpWidget(AppGadget(
      child: Container(),
      beans: {toBeanKey(MockBean): MockBean()},
    ));
    expect(ServiceContainer.instance.get<MockService>(), isNull);
    expect(ServiceContainer.instance.observableModel.getBean<MockBean>(), isNotNull);

    await tester.pumpWidget(Container());
  });
}
