import 'package:flutter/material.dart';
import 'package:flutter_gadgets/flutter_gadgets.dart';
import 'package:flutter_test/flutter_test.dart';

import '../utils.dart';

void main() {
  testWidgets('ViewModelGadget test', (tester) async {
    await tester.pumpWidget(
      AppGadget(
        child: ViewModelGadget(
          MockViewModel(),
          initStateCallback: (MockViewModel viewModel) => viewModel.state = 10,
          child: Container(),
        ),
      ),
    );
    MockViewModel viewModel =
        ServiceContainer.instance.observableModel.getBean<MockViewModel>();
    expect(viewModel, isNotNull);
    expect(viewModel.state, 10);
  });
}
